/**
 *	@file	GetPixelsAppUi.h
 *	@author	ENDO
 */

#ifndef __GETPIXELSAPPUI_H__
#define __GETPIXELSAPPUI_H__

#include <aknviewappui.h>		// for CAknViewAppUi.

#include "ImageSaver.h"			// for MImageSaverObserver.
#include "KeyEventWatcher.h"	// for MKeyEventObserver.
#include "SystemEventWatcher.h"	// for MSystemEventObserver.

class CEikonEnv;
class CFbsBitmap;
class CAknGlobalNote;
class CVibraControl;
class CPeriodic;
class CGetPixelsMainView;
class CGetPixelsSettingsView;
class CGetPixelsImageSettingsView;
class CGetPixelsSettings;
class CScreenCaptor;
class CGetPixelsAppUi : public CAknViewAppUi, public MImageSaverObserver, public MKeyEventObserver, public MSystemEventObserver
	{
public:
	CGetPixelsAppUi(void);
	virtual ~CGetPixelsAppUi();

private:
	void ConstructL(void);

public:
	// from CEikAppUi.
	void HandleCommandL(TInt aCommand);
	void HandleModelChangeL(void);

	// from CCoeAppUi.
	TKeyResponse HandleKeyEventL(const TKeyEvent& aKeyEvent, TEventCode aType);

private:
	// from MImageSaverObserver.
	void NotifyCompletion(TInt aStatus);

	// from MKeyEventObserver.
	void NotifyGlobalKeyEvent(const TWsEvent& aEvent);

	// from MSystemEventObserver.
	void NotifySystemEvent(const TSysAgentEvent& aSysAgentEvent);

public:
	void RestartWatchingKeyEventL(TUint aScanCode);
	void RestartWatchingSystemEventL(TUid aUid);

	CGetPixelsSettings* GetModel(void) const;
	const CFbsBitmap* CapturedBitmap(void) const;
	const TDesC& CapturedImageFilePath(void) const	{return iCapturedImageFilePath;};

private:
	void CommandCaptureL(void);
	void CommandTriggerTimerL(void);

	static TInt PeriodicTimerCallbackHandler(TAny* aPtr);

private:
	CEikonEnv* const iEnv;

	CGetPixelsMainView* iMainView;
	CGetPixelsSettingsView* iSettingsView;
	CGetPixelsImageSettingsView* iImageSettingsView;

	CPeriodic* iPeriodicTimer;
	CAknGlobalNote* iGlobalNote;
	CVibraControl* iVibraController;

	CScreenCaptor* iScreenCaptor;
	CImageSaver* iImageSaver;
	CKeyEventWatcher* iKeyEventWatcher;
	CSystemEventWatcher *iSystemEventWatcher;

	TFileName iCapturedImageFilePath;
	RArray<TUid> iViewHistoryStack;
	};

#endif // __GETPIXELSAPPUI_H__
