/**
 *	@file	GetPixelsDocument.h
 *	@author	ENDO
 */

#ifndef __GETPIXELSDOCUMENT_H__
#define __GETPIXELSDOCUMENT_H__

#include <akndoc.h>	// for CAknDocument.

class CEikApplication;
class CGetPixelsAppUi;
class CGetPixelsSettings;
class CGetPixelsDocument : public CAknDocument
	{
public:
	static CGetPixelsDocument* NewL(CEikApplication& aApp);
	static CGetPixelsDocument* NewLC(CEikApplication& aApp);
	virtual ~CGetPixelsDocument();

private:
	CGetPixelsDocument(CEikApplication& aApp);
	void ConstructL(void);

public:
	// from CEikDocument.
	CEikAppUi* CreateAppUiL(void);
	CFileStore* OpenFileL(TBool aDoOpen,const TDesC& aFilename,RFs& aFs);
	void StoreL(CStreamStore& aStore, CStreamDictionary& aStreamDic) const;
	void RestoreL(const CStreamStore& aStore, const CStreamDictionary& aStreamDic);

public:
	CGetPixelsSettings* Model(void) const	{return iModel;};

private:
	CGetPixelsSettings* iModel;
	};

#endif // __GETPIXELSDOCUMENT_H__
