/**
 *	@file	KeyEventWatcher.h
 *	@author	ENDO
 */

#ifndef __KEYEVENTWATCHER_H__
#define __KEYEVENTWATCHER_H__

#include <w32std.h>		// for RWsSession, RWindowGroup, TWsEvent.

class MKeyEventObserver
	{
public:
	virtual void NotifyGlobalKeyEvent(const TWsEvent& aEvent) = 0;
	};

class CApaWindowGroupName;
class CKeyEventWatcher : public CActive
	{
public:
	static CKeyEventWatcher* NewL(RWindowGroup& aWindowGroup, MKeyEventObserver* aObserver = NULL);
	virtual ~CKeyEventWatcher();

private:
	CKeyEventWatcher(RWindowGroup& aWindowGroup, MKeyEventObserver* aObserver);
	void ConstructL(void);

public:
	void StartCaptureKeyL(TUint aKeyCode, TUint aModifierMask, TUint aModifier);
	void StartCaptureKeyUpAndDownsL(TUint aScanCode, TUint aModifierMask, TUint aModifier);

private:
	// from CActive.
	void RunL(void);
	void DoCancel(void);

private:
	MKeyEventObserver* const iObserver;
	RWsSession iWsSession;
	RWindowGroup* iWindowGroup;
	CApaWindowGroupName* iWindowGroupName;
	TInt32 iCaptureKeyHandle;
	TInt32 iCaptureKeyUpAndDownsHandle;
	TInt iId;
	};

#endif	// __KEYEVENTWATCHER_H__
