/**
 *	@file	SystemEventWatcher.h
 *	@author	ENDO
 */

#ifndef __SYSTEMEVENTWATCHER_H__
#define __SYSTEMEVENTWATCHER_H__

#include <e32base.h>	// for CActive.
#include <saclient.h>	// for RSystemAgent, TSysAgentEvent.

class MSystemEventObserver
	{
public:
	virtual void NotifySystemEvent(const TSysAgentEvent& aSysAgentEvent) = 0;
	};

class CSystemEventWatcher : public CActive
	{
public:
	static CSystemEventWatcher* NewL(MSystemEventObserver& aObserver);
	virtual ~CSystemEventWatcher();

private:
	CSystemEventWatcher(MSystemEventObserver& aObserver);
	void ConstructL(void);

public:
	void StartL(TUid aUid);

private:
	// from CActive.
	void RunL(void);
	void DoCancel(void);

private:
	MSystemEventObserver& iObserver;
	RSystemAgent iSystemAgent;
	TSysAgentEvent iSysAgentEvent;
	};

#endif	// __SYSTEMEVENTWATCHER_H__
