/**
 *	@file	GetPixelsMainView.cpp
 *	@author	ENDO
 */

#include <aknview.h>		// for CAknView.
#include <aknviewappui.h>	// for CAknViewAppUi.

#include <GetPixels.rsg>
#include "GetPixels.hrh"
#include "GetPixelsAppUi.h"
#include "GetPixelsMainView.h"
#include "GetPixelsMainContainer.h"

CGetPixelsMainView* CGetPixelsMainView::NewL(void)
	{
	CGetPixelsMainView* self = new(ELeave) CGetPixelsMainView;
	CleanupStack::PushL(self);
	self->ConstructL();
	CleanupStack::Pop(self);
	return self;
	}

CGetPixelsMainView::CGetPixelsMainView(void) :
	iAppUi(*reinterpret_cast<CGetPixelsAppUi*>(AppUi()))
	{
	}

void CGetPixelsMainView::ConstructL(void)
	{
	BaseConstructL(R_GETPIXELS_VIEW_MAIN);
	}

CGetPixelsMainView::~CGetPixelsMainView()
	{
	delete iContainer;
	}

void CGetPixelsMainView::DrawDeferred(void) const
	{
	if (iContainer != NULL)
		{
		iContainer->DrawDeferred();
		}
	}

TUid CGetPixelsMainView::Id(void) const
	{
	return TUid::Uid(EGetPixelsMainViewId);
	}

void CGetPixelsMainView::DoActivateL(const TVwsViewId& /* aPrevViewId */, TUid /* aCustomMessageId */, const TDesC8& /* aCustomMessage */)
	{
	if (iContainer == NULL)
		{
		iContainer = CGetPixelsMainContainer::NewL(iAppUi.ClientRect(), iAppUi);
		iContainer->SetMopParent(this);
		iAppUi.AddToStackL(*this, iContainer);
		}
	}

void CGetPixelsMainView::DoDeactivate(void)
	{
	if (iContainer != NULL)
		{
		iAppUi.RemoveFromStack(iContainer);
		delete iContainer;
		iContainer = NULL;
		}
	}

void CGetPixelsMainView::HandleCommandL(TInt aCommand)
	{
	switch (aCommand)
		{
	case EAknSoftkeyBack:
		iAppUi.HandleCommandL(EEikCmdExit);
		break;

	default:
		iAppUi.HandleCommandL(aCommand);
		}
	}
