/**
 *	@file	GetPixelsSettingsView.cpp
 *	@author	ENDO
 */

#include <aknview.h>		// for CAknView.
#include <aknviewappui.h>	// for CAknViewAppUi.

#include <GetPixels.rsg>
#include "GetPixels.hrh"
#include "GetPixelsDocument.h"
#include "GetPixelsAppUi.h"
#include "GetPixelsSettingsView.h"
#include "GetPixelsSettingsContainer.h"
#include "GetPixelsSettings.h"

CGetPixelsSettingsView* CGetPixelsSettingsView::NewL(void)
	{
	CGetPixelsSettingsView* self = new(ELeave) CGetPixelsSettingsView;
	CleanupStack::PushL(self);
	self->ConstructL();
	CleanupStack::Pop(self);
	return self;
	}

CGetPixelsSettingsView::CGetPixelsSettingsView(void) :
	iAppUi(*reinterpret_cast<CGetPixelsAppUi*>(AppUi()))
	{
	}

void CGetPixelsSettingsView::ConstructL(void)
	{
	BaseConstructL(R_GETPIXELS_VIEW_SETTINGS);
	}

CGetPixelsSettingsView::~CGetPixelsSettingsView()
	{
	delete iContainer;
	}

TUid CGetPixelsSettingsView::Id(void) const
	{
	return TUid::Uid(EGetPixelsSettingsViewId);
	}

void CGetPixelsSettingsView::DoActivateL(const TVwsViewId& /* aPrevViewId */, TUid /* aCustomMessageId */, const TDesC8& /* aCustomMessage */)
	{
	if (iContainer == NULL)
		{
		iContainer = CGetPixelsSettingsContainer::NewL(iAppUi.ClientRect());
		iContainer->SetMopParent(this);
		iAppUi.AddToStackL(*this, iContainer);
		}

	iContainer->ReadSettingsFromModelL(*iAppUi.GetModel());
	}

void CGetPixelsSettingsView::DoDeactivate(void)
	{
	if (iContainer != NULL)
		{
//		iContainer->WriteSettingsToModelL(*iAppUi.GetModel());

		iAppUi.RemoveFromStack(iContainer);
		delete iContainer;
		iContainer = NULL;
		}
	}

void CGetPixelsSettingsView::HandleCommandL(TInt aCommand)
	{
	switch (aCommand)
		{
	case ECommandChange:
		iContainer->ChangeSelectedItemL();
		break;

	case EAknSoftkeyBack:
		iAppUi.HandleCommandL(ECommandBackToPreviousView);
		break;

	default:
		iAppUi.HandleCommandL(aCommand);
		break;
		}
	}
